#! /usr/bin/env python
# -*- coding: utf-8 -*-

# Copyright (c) 2008 Manuel Holtgrewe, Mathias Ziebarth, Lucas Lürich, Joachim Breitner
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

from random import randint
from math import sqrt, ceil, floor, log

import time
import sys
import struct

def sieveOfAtkin(end):
    end += 1
    lng = ((end/2)-1+end%2)
    sieve = [False]*(lng + 1)

    x_max, x2, xd = int(sqrt((end-1)/4.0)), 0, 4
    for xd in range(4, 8*x_max + 2, 8):
        x2 += xd
        y_max = int(sqrt(end-x2))
        n, n_diff = x2 + y_max**2, (y_max << 1) - 1
        if n%2 == 0:
            n -= n_diff
            n_diff -= 2
        for d in range((n_diff - 1) << 1, -1, -8):
            m = n%12
            if (m == 1 or m == 5):
                    m = n >> 1
                    sieve[m] = not sieve[m]
            n -= d
                
    x_max, x2, xd = int(sqrt((end-1)/3.0)), 0, 3
    for xd in range(3, 6*x_max + 2, 6):
        x2 += xd
        y_max = int(sqrt(end-x2))
        n, n_diff = x2 + y_max**2, (y_max << 1) - 1
        if n%2 == 0:
            n -= n_diff
            n_diff -= 2
        for d in range((n_diff - 1) << 1, -1, -8):
            if (n%12 == 7):
                    m = n >> 1
                    sieve[m] = not sieve[m]
            n -= d
                
    x_max, y_min, x2, xd = int((2 + sqrt(4-8*(1-end)))/4), -1, 0, 3
    for x in range(1, x_max + 1):
        x2 += xd
        xd += 6
        if x2 >= end: y_min = (((int(ceil(sqrt(x2 - end))) - 1) << 1) - 2) << 1
        n, n_diff = ((x**2 + x) << 1) - 1, (((x-1) << 1) - 2) << 1
        for d in range(n_diff, y_min, -8):
            if (n%12 == 11):
                    m = n >> 1
                    sieve[m] = not sieve[m]
            n += d

    primes = [2,3]
    if end <= 3 : return primes[:max(0,end-2)]
    
    for n in range(5 >> 1, (int(sqrt(end))+1) >> 1):
        if sieve[n]:
            primes.append((n << 1) + 1)
            for k in range(((n << 1) + 1)**2, end, 2*((n << 1) + 1)**2):
                sieve[k >> 1] = False

    s  = int(sqrt(end)) + 1
    if s%2 == 0: s += 1
    primes.extend([ i for i in range(s, end, 2) if sieve[i >> 1]])
    
    return primes

f=file("../data/primenumbers.dump", "w")
primenumbers = sieveOfAtkin(10**7)
for pn in primenumbers:
    f.write(struct.pack("i", pn))

# vim:sw=4:ts=4:sts=4:expandtab
