#!/bin/bash

# Copyright (c) 2008 Manuel Holtgrewe, Mathias Ziebarth, Lucas Lürich, Joachim Breitner
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

set -e

if ! test -d bin/ && test -d lib/
then
	echo "Please run from main 7down dir"
fi

dir=$(mktemp -d)
mkdir -p $dir/7down/lib/gui
mkdir -p $dir/7down/lib/sevendown
mkdir -p $dir/7down/bin
mkdir -p $dir/7down/doc/latex
mkdir -p $dir/7down/tests/examples
mkdir -p $dir/7down/tests
mkdir -p $dir/7down/data

(
	cd doc/latex;
	echo "Re-Building docs"
	bibtex book
	bibtex book
	pdflatex book.tex
	pdflatex book.tex
	pdflatex book.tex
)

for file in lib/sevendown/*.py lib/gui/*.py bin/solve-puzzle.py \
	tests/examples/* tests/*.py tests/*.sh \
	data/* 
do
	install $file $dir/7down/$file
done
install doc/latex/book.pdf $dir/7down/documentation.pdf
install doc/README $dir/7down/README.txt

echo Packing up files:

tar  --create --verbose --file /tmp/sevendown.tar.gz --gzip  --directory $dir 7down
rm -rf $dir

echo Created file /tmp/sevendown.tar.gz
