#! /usr/bin/env python
# -*- coding: utf-8 -*-
# Copyright (c) 2008 Manuel Holtgrewe, Mathias Ziebarth, Lucas Lürich, Joachim Breitner
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


import unittest

import test_utils
import sevendown
from sevendown.binlist import BinList
from itertools import takewhile, dropwhile

class BinListTestCase(test_utils.TestCase):
    """Test the NoLeadingZeroRule."""
    
    def setUp(self):
        self.l = BinList(sevendown.__path__[0] + "/../../data/primenumbers.dump")

    def tearDown(self):
        pass
    
    def testLenght(self):
        self.assert_(len(self.l) > 0)

    def testFirstPrime(self):
        self.assertEqual(self.l[0],2)

    def testSecond(self):
        self.assertEqual(self.l[1],3)

    def testLast(self):
        self.assert_(self.l[-1]>0)

    def testContains(self):
        self.assert_(101 in self.l)

    def testIter(self):
        self.assertEqual(
                len(list(takewhile(lambda n: n<10**4, dropwhile(lambda n: n<10**3, self.l)))),
                1061)

# Execute unit tests when called standalone.
if __name__ == "__main__":
    unittest.main()

# vim:sw=4:ts=4:sts=4:expandtab
